
#cs

TODO:

1. If not found, try to find string in whole lines, and if found, add whole text after tab to clipboard and to tooltip
2. Find a way to add segments to TM while TM is loaded (add to array), possibly by user pressing a shortcut that opens an inputbox in which you put a triple pipe between SL and TL

#ce

#include <Misc.au3>

; memoqwebtrans

#include <Process.au3>
#Include <Array.au3>

Global $fileopenhtml, $glossaryfilecolumns, $glossaryfilelines, $glossaryfileopen, $glossaryfileopendialog, $glossaryfileread, $grabbedtext, $grabbedword, $grabbedwordarray, $htmloutput, $i, $j, $k, $l, $output, $found

MsgBox (0, "memoQwebtrans TranzVoo (hotkey) v.02", "The shortcuts are:" & @CRLF & @CRLF & "
` = seek and paste" & @CRLF & @CRLF & "
F4 = copy source to target" & @CRLF & @CRLF & "
Alt + 1 = go to previous segment" & @CRLF & "
Alt + 2 = go to next segment" & @CRLF & @CRLF & "
Win + Q = exit", 0)

; HotKeySet("{NUMPADADD}", "seekandpaste")
; HotKeySet("^{NUMPADSUB}", "seekandkeep")

HotKeySet("!1", "goprevious")
HotKeySet("!2", "gonext")
; HotKeySet("!q", "wait")

HotKeySet("{F4}", "copysourcetotarget")

HotKeySet ("`", "seekandpaste")

HotKeySet("#q", "exitty")

$glossaryfileopendialog = FileOpenDialog ("Select mini-TM", @ScriptDir, "Text files (*.txt)|All files (*.*)") ; uncomment this to be asked for glossary at start of run

$FSD = FileSaveDialog ("Choose file name to save unfound text", @ScriptDir, "Text files (*.txt)|All files (*.*)", "not found.txt")
$FOD = FileOpen ($FSD, 129)

#cs
$glossaryfileopendialog = @ScriptDir & "\mini-TM.txt" ; comment this if you uncomment the above
#ce

$glossaryfileopen = FileOpen ($glossaryfileopendialog, 128) ; 128 means UTF8, 32 means UTF16LE
$glossaryfileread = FileRead ($glossaryfileopen)

$glossaryfilelines = StringSplit ($glossaryfileread, @CRLF, 3)

Global $glossaryfilefirstcolumn[UBound ($glossaryfilelines)]
Global $glossaryfilesecondcolumn[UBound ($glossaryfilelines)]

For $i = 0 to UBound ($glossaryfilelines) - 1
$glossaryfilecolumns = StringSplit ($glossaryfilelines[$i], @TAB, 3)
If UBound ($glossaryfilecolumns) = 2 Then ; i.e. if there is 2 columns in the line
$glossaryfilefirstcolumn[$i] = $glossaryfilecolumns[0]
$glossaryfilesecondcolumn[$i] = $glossaryfilecolumns[1]

$glossaryfilefirstcolumn[$i] = StringReplace ($glossaryfilefirstcolumn[$i], "{{CRLF}}", @CRLF)
$glossaryfilesecondcolumn[$i] = StringReplace ($glossaryfilesecondcolumn[$i], "{{CRLF}}", @CRLF)

$glossaryfilefirstcolumn[$i] = StringReplace ($glossaryfilefirstcolumn[$i], "{{LF}}", @LF)
$glossaryfilesecondcolumn[$i] = StringReplace ($glossaryfilesecondcolumn[$i], "{{LF}}", @LF)

$glossaryfilefirstcolumn[$i] = StringReplace ($glossaryfilefirstcolumn[$i], "{{CR}}", @LF)
$glossaryfilesecondcolumn[$i] = StringReplace ($glossaryfilesecondcolumn[$i], "{{CR}}", @LF)

$glossaryfilefirstcolumn[$i] = StringReplace ($glossaryfilefirstcolumn[$i], "{{TAB}}", @LF)
$glossaryfilesecondcolumn[$i] = StringReplace ($glossaryfilesecondcolumn[$i], "{{TAB}}", @LF)

EndIf
Next

; MsgBox (0, "", _ArrayToString($glossaryfilefirstcolumn, " | "), 0) ; If you want to check that the entire glossary was read
; MsgBox (0, "", _ArrayToString($glossaryfilesecondcolumn, " | "), 0) ; If you want to check that the entire glossary was read

Sleep ("5000")

While 1

#cs
Local $hDLL = DllOpen("user32.dll")

If _IsPressed("01", $hDLL) Then
While _IsPressed("01", $hDLL)
Sleep ("500")
WEnd
seekandpaste ()
EndIf
Sleep ("100")

#ce

WEnd

Func goprevious ()
Send ("+{HOME}")
Send ("{UP}")
EndFunc

Func gonext ()
Send ("!{END}")
Send ("{DOWN}")
EndFunc

Func exitty ()
Exit
EndFunc


#cs
Func seekandpaste2 ()

$mouse = MouseGetPos ()
MouseClick ("left", $mouse[0], $mouse[1], 1, 0)
Sleep ("200")
seekandpaste ()
EndFunc
#ce


Func copysourcetotarget ()

Send ("{TAB}")
Sleep ("50")
Send ("^a")
Sleep ("50")
Send ("^c")
Sleep ("50")
$grabbedtext = ClipGet ()
Sleep ("200")
Send ("{TAB}")
Sleep ("50")
ClipPut ($grabbedtext)
Sleep ("200")
Send ("^a")
Sleep ("100")
Send ("^v")
Sleep ("100")
Send ("{DOWN}")

EndFunc

Func seekandpaste ()

Send ("{TAB}")
Sleep ("50")
Send ("^a")
Sleep ("50")
Send ("^c")
Sleep ("50")
$grabbedtext = ClipGet ()
Sleep ("200")

Send ("{TAB}")
Sleep ("50")

$output = ""
$found = 0

For $m = 0 to UBound ($glossaryfilelines) - 1

If $found = 0 Then
If StringCompare ($grabbedtext, $glossaryfilefirstcolumn[$m], 1) =  0 Then
; If $grabbedtext = $glossaryfilefirstcolumn[$m] Then
$output = $glossaryfilesecondcolumn[$m]
$found = 1
EndIf
EndIf

Next

If $found = 0 Then
$output = "`" & $grabbedtext
FileWrite ($FOD, "{{" & $output & "}}" & @CRLF)
MsgBox (0, "", "not found", 0)
ClipPut ($output)
Else

; Sleep ("200")
ClipPut ($output)
Sleep ("200")

; Send ("^a")
; Sleep ("100")

Send ("^a")
Sleep ("100")
Send ("^v")
Sleep ("100")
Send ("{DOWN}")

EndIf

#cs

; then copy whatever is in the target field at that time.
; and show it as a tooltip

ClipPut ("[asdfasdf]")

Send ("^z")
Sleep ("100")
Send ("^z")
Sleep ("100")
Send ("^a")
Sleep ("100")
Send ("^c")
Sleep ("100")
$TTip = ClipGet ()
Sleep ("200")

If $TTip = "[asdfasdf]" Then
$TTip = "[no existing target text]"
EndIf

ToolTip ($TTip)

#ce

EndFunc

