﻿

#cs

version 2: ask to skip check for empty segments
version 3: checks if segment was already copied, and if so, don't copy it again
version 3a: also loads already extracted segments to check against.

==

this version checks if target is empty, and if so, extracts the source, but if target has something in it, it moves to the next segment

#ce

AutoItSetOption ("WinTitleMatchMode", 2)

$clippyold1 = 0
$clippyold2 = 0
$clippyold3 = 0
$clippyold4 = 0

$allclippies = ":::asdf;;;"

$numsegs = InputBox ("How many segments?", "How many segments do you want to extract?", "10")

$wintitle = InputBox ("Title of the browser window", "Enter a few unique characters from the browser window title", "memoQWebTrans")

$skipnonempty = MsgBox (4, "Skip non-empty targets?", "Skip non-empty targets?  If yes, script will not extract a segment if it has target text.", 0) ; 6 = yes

$skiprepeats = MsgBox (4, "Skip repeated *translated* segments?", "Skip *translated* segments that have already been extracted?  If yes, script is faster.", 0)
; not extracting repeated source texts does not really make the script faster

$savefilewhat = FileSaveDialog ("Save extracted text under what name?", @ScriptDir, "Text files (*.txt)|All files (*.*)", 18)

If $skiprepeats = 6 Then
$previousfile = FileOpen ($savefilewhat, 128)
$previousfilecontent = FileRead ($previousfile)
MsgBox (0, "", $previousfilecontent, 0)
$previousfilecontent = StringReplace ($previousfilecontent, @TAB, @TAB & ":::")
$previousfilecontent = StringReplace ($previousfilecontent, @CRLF, ";;;" & @CRLF)
$allclippies = $allclippies & $previousfilecontent
MsgBox (0, "", $allclippies, 0)
FileClose ($previousfile)
EndIf

$savefile = FileOpen ($savefilewhat, 129)

MsgBox (0, "Click in target field...", "Remember, first click in the target field.", 0)

Sleep ("2000")

For $i = 1 to $numsegs

$clippy = "{{EMPTY TARGET}}"

WinWaitActive ($wintitle, "")

ClipPut ("asdfasdfasdfasdfasdf")
Sleep ("200")

Send ("^a")
Sleep ("100")
Send ("^c")
Sleep ("100")

$clippy = ClipGet ()
Sleep ("300")

If $clippy = "asdfasdfasdfasdfasdf" Then
$j = 1
Else

If $skipnonempty = 6 Then
Send ("{DOWN}")
ToolTip ("[" & $i & "/" & $numsegs & "]")
ContinueLoop
EndIf

If $skiprepeats = 6 Then
$clippywithesps = ":::" & $clippy & ";;;"
If StringInStr ($allclippies, $clippywithesps) Then
Send ("{DOWN}")
ToolTip ("[" & $i & "/" & $numsegs & "]")
ContinueLoop
Else
$allclippies = $allclippies & $clippywithesps
EndIf
EndIf

EndIf

Send ("{TAB}")
Send ("^a")
Sleep ("100")
Send ("^c")
Sleep ("100")

$clappy = ClipGet ()
Sleep ("300")

FileWrite ($savefile, $clappy & @TAB & $clippy & @CRLF)

ToolTip ("[" & $i & "/" & $numsegs & "]" & @CRLF & "---" & @CRLF & $clappy & " :: " & $clippy & @CRLF & "---" & @CRLF & $clippyold1 & @CRLF & "---" & @CRLF & $clippyold2 & @CRLF & "---" & @CRLF & $clippyold3 & @CRLF & "---" & @CRLF & $clippyold4 & @CRLF & "---")

$clippyold4 = $clippyold3
$clippyold3 = $clippyold2
$clippyold2 = $clippyold1
$clippyold1 = $clappy & " :: " & $clippy

Send ("{DOWN}")

Next



